using System;
using System.Drawing;
using System.Collections;
using System.ComponentModel;
using System.Windows.Forms;
using System.Data;
using O2S.Barcode4NET;

namespace CrystalReportsBarcodes
{
	/// <summary>
	/// Application's main form.
	/// </summary>
	public class MainForm : System.Windows.Forms.Form
    {
        private CrystalDecisions.Windows.Forms.CrystalReportViewer crystalReportViewer;
		/// <summary>
		/// Required designer variable.
		/// </summary>
		private System.ComponentModel.Container components = null;

		public MainForm()
		{
			//
			// Required for Windows Form Designer support
			//
			InitializeComponent();

			//
			// TODO: Add any constructor code after InitializeComponent call
			//
		}

		/// <summary>
		/// Clean up any resources being used.
		/// </summary>
		protected override void Dispose( bool disposing )
		{
			if( disposing )
			{
				if (components != null) 
				{
					components.Dispose();
				}
			}
			base.Dispose( disposing );
		}

		#region Windows Form Designer generated code
		/// <summary>
		/// Required method for Designer support - do not modify
		/// the contents of this method with the code editor.
		/// </summary>
		private void InitializeComponent()
		{
            System.ComponentModel.ComponentResourceManager resources = new System.ComponentModel.ComponentResourceManager(typeof(MainForm));
            this.crystalReportViewer = new CrystalDecisions.Windows.Forms.CrystalReportViewer();
            this.SuspendLayout();
            // 
            // crystalReportViewer
            // 
            this.crystalReportViewer.ActiveViewIndex = -1;
            this.crystalReportViewer.BorderStyle = System.Windows.Forms.BorderStyle.FixedSingle;
            this.crystalReportViewer.DisplayGroupTree = false;
            this.crystalReportViewer.Dock = System.Windows.Forms.DockStyle.Fill;
            this.crystalReportViewer.Location = new System.Drawing.Point(0, 0);
            this.crystalReportViewer.Name = "crystalReportViewer";
            this.crystalReportViewer.SelectionFormula = "";
            this.crystalReportViewer.Size = new System.Drawing.Size(508, 273);
            this.crystalReportViewer.TabIndex = 0;
            this.crystalReportViewer.ViewTimeSelectionFormula = "";
            // 
            // MainForm
            // 
            this.AutoScaleBaseSize = new System.Drawing.Size(5, 14);
            this.ClientSize = new System.Drawing.Size(508, 273);
            this.Controls.Add(this.crystalReportViewer);
            this.Font = new System.Drawing.Font("Tahoma", 8.25F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, ((byte)(0)));
            this.Icon = ((System.Drawing.Icon)(resources.GetObject("$this.Icon")));
            this.Name = "MainForm";
            this.Text = "Barcode4NET - Crystal Reports demo";
            this.WindowState = System.Windows.Forms.FormWindowState.Maximized;
            this.Load += new System.EventHandler(this.MainForm_Load);
            this.ResumeLayout(false);

		}
		#endregion

		/// <summary>
		/// The main entry point for the application.
		/// </summary>
		[STAThread]
		static void Main() 
		{
			Application.Run(new MainForm());
		}

		private void MainForm_Load(object sender, System.EventArgs e)
		{
			// Load the customers dataset.
			DataSet customers = new DataSet( );
			// The path is relative to the exe file.
			customers.ReadXml("..\\..\\Samples\\Windows Forms\\CrystalReportsBarcodes\\CS\\Net 2.0\\customers.net20.xml", XmlReadMode.ReadSchema);

			// Create a new column in the dataset that will store the barcode
			// The column name must match the CustomerIDBarcode column in Customers.xsd
			DataColumn dc = new DataColumn("CustomerIDBarcode", typeof(byte[]));

			//Add the CustomerIDBarcode column to the DataTable
			customers.Tables[0].Columns.Add(dc);

			//Create a Code39 barcode object to fill the CustomerIDBarcode column
			Code39Barcode barcode = new Code39Barcode();
			barcode.DimensionUnit = XYDimensionUnit.Mil;
			barcode.XDimension = 12;
			barcode.YDimension = 500;

			// Fill each row with the barcode image
			foreach (DataRow dr in customers.Tables[0].Rows)
			{
				barcode.Data = (string)dr["CustomerID"];
				dr["CustomerIDBarcode"] = barcode.GetImageData(BarcodeImageFormat.Png, 300);
			}

			// Create the report and attach the data source
			CustomersReport customersReport = new CustomersReport();
			customersReport.SetDataSource(customers.Tables[0]);

			// Display the report in the viewer
			crystalReportViewer.ReportSource = customersReport;
		}
	}
}
